/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	NavApiBusinessAction
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.ObjectInputStream;
import java.util.Hashtable;
import java.util.Iterator;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.lo.scorm.kernel.Activity;
import jp.co.ntt.lms.lo.scorm.util.Debug;
import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;

/**
 *	NavApiBusinessAction クラス<br>
 *	GetValue / SetValue 要求を受け付けるクラス<br>
 */
public class NavApiBusinessAction extends XmsBusinessAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public NavApiBusinessAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {}

	/**
	 * GetValue / SetValue 要求受付処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		HttpServletRequest request = xmsRequest.getRequest();
		HttpSession session = request.getSession();
		ServletContext application = session.getServletContext();

		String errorCode = "0";
		String nextURL = "";
		String result = null;

		// 起動パラメータをsessionから取得する
		ExecuteParameters executeParameters = (ExecuteParameters)session.getAttribute("SCORM.EXECUTE_PARAMETERS");

		// api adapterをsessionから取得する
		SCORMAPIAdapter adapter = (SCORMAPIAdapter)session.getAttribute("SCORM.API_ADAPTER");

		try {
			StringBuffer param = new StringBuffer();
			Iterator iterator = xmsRequest.getParmaterNames().iterator();
			String method = null;
			String dataModelName = null;
			String parameter = null;
			String parameter1 = null;
			String parameter2 = null;
			while (iterator.hasNext()) {
				String key = (String)iterator.next();
				String value = xmsRequest.getParameter(key);
				
				if (key.equalsIgnoreCase("Method")) {
					method = value;
				}else if (key.equalsIgnoreCase("DataModel")) {
					dataModelName = value;
				}else if (key.equalsIgnoreCase("Parameter")) {
					parameter = value;
				}else if (key.equalsIgnoreCase("Parameter1")) {
					parameter1 = value;
				}else if (key.equalsIgnoreCase("Parameter2")) {
					parameter2 = value;
				}
				
			}
			
			// エンジンをapplicationから取得する
			Engine engine = null;

			if (executeParameters != null) {
				String engineKeyName =
					"SCORM." + executeParameters.getUserID() + "." + executeParameters.getLOID() + ".ENGINE";

				engine = (Engine)application.getAttribute(engineKeyName);
			}

			do {
				// "Method"パラメータを取得する

				// "GetValue"の場合
				if (method.equals("GetValue")) {
					result = "";

					// session timeout が発生している場合
					if (executeParameters == null) {
						// エラーコードはsession timeout
						errorCode = "1001";
						break;
					}

					// データモデル名取得する

					// データモデル名を"."で分割する
					String[] splittedDataModel = dataModelName.split("\\.");

					// "."で分割した結果が3つの文字列以下の場合
					// → "adl.nav.request_valid.xxxx"のはず
					if (splittedDataModel.length <= 3) {
						// undefined data model element
						errorCode = "401";
						break;
					}

					// "adl.nav.request_valid.xxxx"でない場合
					if (!splittedDataModel[0].equals("adl")
						|| !splittedDataModel[1].equals("nav")
						|| !splittedDataModel[2].equals("request_valid")) {

						// undefined data model element
						errorCode = "401";
						break;
					}

					// "adl.nav.request_valid.continue"の場合
					if (splittedDataModel[3].equals("continue")) {

						// "adl.nav.request_valid.continue.xxxxx"の場合
						if (splittedDataModel.length != 4) {
							// undefined data model element
							errorCode = "401";
							break;
						}

						// continue可能かどうかを設定する
						result = Boolean.toString(engine.canContinue());
						break;
					}

					// "adl.nav.request_valid.previous"の場合
					if (splittedDataModel[3].equals("previous")) {

						// "adl.nav.request_valid.previous.xxxxx"の場合
						if (splittedDataModel.length != 4) {
							// undefined data model element
							errorCode = "401";
							break;
						}

						// previous可能かどうかを設定する
						result = Boolean.toString(engine.canPrevious());
						break;
					}

					// "adl.nav.request_valid.choice.{target=URI}"の場合
					if (splittedDataModel[3].equals("choice")) {

						// "adl.nav.request_valid.choice.xxxxx"ではない場合
						if (splittedDataModel.length <= 4) {
							// general get failure
							errorCode = "301";
							break;
						}

						int targetIndex = splittedDataModel[4].indexOf("{target=");
						int choiceIndex = splittedDataModel[4].lastIndexOf("}");

						if ((targetIndex == -1) || (choiceIndex == -1)) {
							// undefined data model element
							errorCode = "401";
							break;
						}

						if ((targetIndex != 0) || ((choiceIndex + "}".length()) != splittedDataModel[4].length())) {
							// undefined data model element
							errorCode = "401";
							break;
						}

						// choice可能かどうかを取得する
						Boolean canChoiceResult =
							engine.canChoice((Activity) null, parameter);

						// 指定されたactivity idが不正な場合
						if (canChoiceResult == null) {
							// general get failure
							errorCode = "301";
							break;
						}

						// choice可能かどうかを設定する
						result = canChoiceResult.toString();
						break;
					}
					
					// 2010.10.05 taku-harada add >>
					// "adl.nav.request_valid.jump.{target=URI}"の場合
					if (splittedDataModel[3].equals("jump")) {

						// "adl.nav.request_valid.jump.xxxxx"ではない場合
						if (splittedDataModel.length <= 4) {
							// general get failure
							errorCode = "301";
							break;
						}

						int targetIndex = splittedDataModel[4].indexOf("{target=");
						int jumpIndex = splittedDataModel[4].lastIndexOf("}");

						if ((targetIndex == -1) || (jumpIndex == -1)) {
							// undefined data model element
							errorCode = "401";
							break;
						}

						if ((targetIndex != 0) || ((jumpIndex + "}".length()) != splittedDataModel[4].length())) {
							// undefined data model element
							errorCode = "401";
							break;
						}

						// jump可能かどうかを取得する
						Boolean canJumpResult =
							engine.canJump((Activity) null, parameter);

						// 指定されたactivity idが不正な場合
						if (canJumpResult == null) {
							// general get failure
							errorCode = "301";
							break;
						}

						// jump可能かどうかを設定する
						result = canJumpResult.toString();
						break;
					}
					// 2010.10.05 taku-harada add <<

					// continue, previous, choiceの何れでもない場合

					// undefined data model element
					errorCode = "401";
					break;
				}
				// "SetValue"の場合
				else if (method.equals("SetValue")) {

					// session timeout が発生している場合
					if (executeParameters == null) {
						// エラーコードはsession timeout
						errorCode = "1001";
						result = "false";
						break;
					}

					// データモデル名取得する
					String dataModel = dataModelName;

					// データモデル名が"adl.nav.request"でない場合
					if (!dataModel.equals("adl.nav.request")) {
						// undefined data model element
						errorCode = "401";
						result = "false";
						break;
					}

					// パラメータを取得する
					parameter = parameter1;

					// "continue"の場合
					if (parameter.equals("continue")) {
						// カレントアクティビティは"continue"ができない場合
						if (!engine.canContinue()) {
							// general set failure
							errorCode = "351";
							result = "false";
							break;
						}

						// "continue"を行うナビゲーションリクエストのURLを作成する
						nextURL = SG.get("BaseServletURL") + "?action_id=scorm.navigate&Command=Continue";
						result = "true";
						break;
					}

					// "previous"の場合
					if (parameter.equals("previous")) {
						// カレントアクティビティは"previous"ができない場合
						if (!engine.canPrevious()) {
							// general set failure
							errorCode = "351";
							result = "false";
							break;
						}

						// "previous"を行うナビゲーションリクエストのURLを作成する
						nextURL = SG.get("BaseServletURL") + "?action_id=scorm.navigate&Command=Previous";
						result = "true";
						break;
					}

					// "exit"の場合
					if (parameter.equals("exit")) {
						// カレントアクティビティは"exit"ができない場合
						if (!engine.canExit()) {
							// general set failure
							errorCode = "351";
							result = "false";
							break;
						}

						// "exit"を行うナビゲーションリクエストのURLを作成する
						nextURL = SG.get("BaseServletURL") + "?action_id=scorm.navigate&Command=Exit";
						result = "true";
						break;
					}

					// "exitAll"の場合
					if (parameter.equals("exitAll")) {
						// カレントアクティビティは"exitAll"ができない場合
						if (!engine.canExitAll()) {
							// general set failure
							errorCode = "351";
							result = "false";
							break;
						}

						// "exitAll"を行うナビゲーションリクエストのURLを作成する
						nextURL = SG.get("BaseServletURL") + "?action_id=scorm.navigate&Command=ExitAll";
						result = "true";
						break;
					}

					// "abandon"と"abandonAll"は未サポート
					if ((parameter.equals("abandon")) || (parameter.equals("abandonAll"))) {
						// unimplemented data model element
						errorCode = "402";
						result = "false";
						break;
					}

					// "adl.nav.request, {target=URI}choice"の場合
					int targetIndex = parameter.indexOf("{target=");
					int choiceIndex = parameter.lastIndexOf("}choice");

					if ((targetIndex == -1) || (choiceIndex == -1)) {
						// undefined data model element
						errorCode = "401";
						result = "false";
						break;
					}

					if ((targetIndex != 0) || ((choiceIndex + "}choice".length()) != parameter.length())) {
						// undefined data model element
						errorCode = "401";
						result = "false";
						break;
					}

					// activity idを取得する
					String activityID = parameter2;

					// 取得したactivity idのアクティビティが"choice"可能かどうかチェックする
					Boolean canChoiceResult = engine.canChoice((Activity) null, activityID);

					// activity idが不正、もしくは"choice"が可能でない場合
					if ((canChoiceResult == null) || (!canChoiceResult.booleanValue())) {
						// general set failure
						errorCode = "351";
						result = "false";
						break;
					}

					// "choice"を行うナビゲーションリクエストのURLを作成する
					nextURL =
						SG.get("BaseServletURL")
							+ "?action_id=scorm.navigate&Command=Choice&ActivityID="
							+ activityID;
					result = "true";
					break;
				}
				// "GetValue", "SetValue"以外の場合
				else {
					// general exception
					errorCode = "101";
					result = "false";
				}
			}
			while (false);
		}
		catch (Exception ex) {
			Debug.write(ex);

			// general exception
			errorCode = "101";
			result = "false";
			nextURL = "";
		}

		NavApiBusinessBean navApiBusinessBean = new NavApiBusinessBean(executeParameters);

		navApiBusinessBean.setErrorCode(errorCode);
		navApiBusinessBean.setNextURL(nextURL);
		navApiBusinessBean.setResult(result);

		xmsResponse.setBusinessBean(navApiBusinessBean);
	}
}
